function result	= calclab(cmd)

math_bkgnd = [.6 .8 1];

if ~nargin
	control_figures = findobj('tag', 'topmenu_main');

	if length(control_figures) == 0
		cmd = 'new';
	else
		figure(control_figures(1));
		cmd = 'NOCOMMAND';
	end
end
								
if strcmp(cmd, 'new')

	fig_han = figure(...
		'name', 'Calculus Lab',...
		'numbertitle', 'off',...
		'menubar', 'figure',...
		'units', 'pixels',...
		'position', [20 20 600 400],...
		'resize', 'off',...
		'color', math_bkgnd,...
		'tag', 'topmenu_main');
		
	uicontrol(fig_han,...
		'style', 'text',...
		'fontname', 'palatino',...
		'fontsize', 36,...
		'backgroundcolor', math_bkgnd,...
		'string', 'Welcome to the Calculus Lab',...
		'position', [10 350 580 30]);
		
	uicontrol(fig_han,...
		'position', [40 240 85 40],...
		'style', 'pushbutton',...
		'string', 'Math 1AM',...
		'callback', 'math1a;calclab(''close'');');

	uicontrol(fig_han,...
		'style', 'text',...
		'fontname', 'palatino',...
		'fontsize', 24,...
		'string', 'Calculus I',...
		'horizontalalignment', 'left',...
		'foregroundcolor', 'b',...
		'backgroundcolor', math_bkgnd,...
		'ButtonDownFcn','math1a;calclab(''close'');',...
		'position', [140 240 200 32]);
				
	uicontrol(fig_han,...
		'position', [40 180 85 40],...
		'style', 'pushbutton',...
		'string', 'Math 1BM',...
		'callback', 'math1b;calclab(''close'');');
		
	uicontrol(fig_han,...
		'style', 'text',...
		'fontname', 'palatino',...
		'fontsize', 24,...
		'string', 'Calculus II',...
		'horizontalalignment', 'left',...
		'foregroundcolor', 'b',...
		'backgroundcolor', math_bkgnd,...
		'ButtonDownFcn','math1b;calclab(''close'');',...
		'position', [140 180 200 32]);

	uicontrol(fig_han,...
		'position', [40 120 85 40],...
		'style', 'pushbutton',...
		'string', 'Math 53M',...
		'callback', 'math53;calclab(''close'');');
		
	uicontrol(fig_han,...
		'style', 'text',...
		'fontname', 'palatino',...
		'fontsize', 24,...
		'string', 'Multivariable Calculus',...
		'horizontalalignment', 'left',...
		'foregroundcolor', 'b',...
		'backgroundcolor', math_bkgnd,...
		'ButtonDownFcn','math53;calclab(''close'');',...
		'position', [140 120 300 32]);

	uicontrol(fig_han,...
		'position', [40 60 85 40],...
		'style', 'pushbutton',...
		'string', 'Math 54M',...
		'callback', 'math54;calclab(''close'');');
		
	uicontrol(fig_han,...
		'style', 'text',...
		'fontname', 'palatino',...
		'fontsize', 24,...
		'string', 'Linear Algebra & Differential Equations',...
		'horizontalalignment', 'left',...
		'foregroundcolor', 'b',...
		'backgroundcolor', math_bkgnd,...
		'ButtonDownFcn','math54;calclab(''close'');',...
		'position', [140 60 450 32]);
			
	% The decorative picture
	
	new_axes = axes('position', [.6 .5 .3 .3]);

	hold on
	axis([0 2*pi -1 1])

	x = linspace(pi, 2*pi);
	plot(x, cos(x+pi/2), 'm');
			
	x = linspace(pi, 2*pi, 10);
	bar(x, cos(x+pi/2))

	x = linspace(0, pi);
	plot(x, cos(x+pi/2), 'k');

	set(new_axes,...
		'xcolor', math_bkgnd,...
		'ycolor', math_bkgnd,...
		'zcolor', math_bkgnd,...
		'xtick', [],...
		'ytick', [])
		
	plot([0 2*pi], [0 0], 'color', math_bkgnd);

	hold off

elseif strcmp(cmd,'close')

	w = findobj('tag', 'topmenu_main');
	for i = 1:length(w)
		delete(w(i))
	end
	
end
