function t = cleanup(s)
% CLEANUP
%
% Strip invisible characters from string.
%
% HISTORY:
% Written January 1998 by Tom Insel.
% Modified March 1998 to parse "e" and "!" by William Stein.
%
% Last update: July 29, 1998.

t = [];

for i = 1:length(s)
	if (real(s(i)) >= 32) & (real(s(i)) <= 126)
		t = [t s(i)]; 
		% MATLAB doesn't parse e as the euler constant so we
		% do that here.  The algorithm is simple: if there is
		% an e in the input and it is not immediately followed
      % by a letter, replace it by exp(1).  
      % This way exp(x) and sec(x) are still parsed correctly. 
		if s(i)=='e' 
			if i==length(s)
				t=[t 'xp(1)'];
         elseif ~((s(i+1)>='a' & s(i+1)<='z') | ...
                  (s(i+1)>='A' & s(i+1)<='Z'))
				t=[t 'xp(1)'];
			end
		end
		
		% if a '!' appears parse it.  i'm not
		% going to explain the below algorithm.
		% basically it replaces (something)! by gamma(something+1)
		% where something is a fairly arbitrary expression.
		if s(i)=='!'  
			j=length(t)-1;
			Nesting=0;
			while j>0
				if t(j)==')'
					Nesting=Nesting+1;
				end
				if Nesting==0 & (t(j)=='+' | t(j)=='-' | t(j)=='*' | t(j)=='/') 
					t=[t(1:j) 'Gamma(' ...
					   t(j+1:length(t)-1) '+1)'];
					j=0;
				elseif t(j)=='(' 
					if Nesting>1
						Nesting=Nesting-1;
					elseif Nesting==1
						t=[t(1:j-1) 'Gamma(' ...
							t(j:length(t)-1) '+1)'];
						j=0;
					else
						t=[t(1:j) 'Gamma(' ...
							t(j+1:length(t)-1) '+1)'];
						j=0;
					end
				elseif j==1
					t=['Gamma(' t(1:length(t)-1) '+1)'];
				end
				j = j-1;
			end
		end
	end
end
